//+------------------------------------------------------------------+
//|                                    MA CrossOver with Filters.mq4 |
//|                                                   Amritendu Maji |
//+------------------------------------------------------------------+
#property copyright "Amritendu Maji"
#property link      "None"

extern int MagicNumber=281987;

extern double Lots=1.0;
extern int Slippage=3;
extern int MaxTrades=1;
extern bool MM = false; //Use Money Management or not
extern int Risk = 5; //10%

extern int StopLoss=100;
//extern int TrailingStopStart=300;
//extern int TrailingStop=50; //25;
extern int TakeProfit=1000; //2000;

//extern int BreakEven=100;

extern int FastMAPeriod=6;
extern int FastMAShift=0;
extern int FastMAMethod=MODE_EMA;
extern int FastMAPrice=PRICE_CLOSE;

extern int SlowMAPeriod=10;
extern int SlowMAShift=0;
extern int SlowMAMethod=MODE_EMA;
extern int SlowMAPrice=PRICE_CLOSE;

extern int ADXPeriod=14;
extern int TimeFrame=60;

bool runnable=true;
bool initialize=true;
string EAName = "MA CrossOver with Filters";
datetime timeprev=0;
bool BC1, BC2, BC3, BC4, BC5, BC6, SC1, SC2, SC3, SC4, SC5, SC6;

int init()
{
 return(0);
}

int deinit()
{
 return(0);
}

int start()
{
//Runnable
 if(runnable!=true)
  return(-1);
  
 
//
//Close/Open
//
 if(timeprev==Time[0])
  return(0);
 timeprev=Time[0];
 
//Trailing Stop
// TrailingAlls(TrailingStopStart,TrailingStop);
 
//Break Even
// BreakEvens(BreakEven);
 
 
//
//Calculations
//
 double fast01=iMA(NULL,TimeFrame,FastMAPeriod,FastMAShift,FastMAMethod,FastMAPrice,1);
 double fast02=iMA(NULL,TimeFrame,FastMAPeriod,FastMAShift,FastMAMethod,FastMAPrice,2);
 double slow01=iMA(NULL,TimeFrame,SlowMAPeriod,SlowMAShift,SlowMAMethod,SlowMAPrice,1);
 double slow02=iMA(NULL,TimeFrame,SlowMAPeriod,SlowMAShift,SlowMAMethod,SlowMAPrice,2);
 double Macd1=iMACD(NULL,TimeFrame,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
 double Macd2=iMACD(NULL,TimeFrame,12,26,9,PRICE_CLOSE,MODE_MAIN,2);
 double Signal1=iMACD(NULL,TimeFrame,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
 double Signal2=iMACD(NULL,TimeFrame,12,26,9,PRICE_CLOSE,MODE_SIGNAL,2);
 double ADX1=iADX(NULL,TimeFrame,ADXPeriod,PRICE_CLOSE,MODE_MAIN,1); 
 double ADX2=iADX(NULL,TimeFrame,ADXPeriod,PRICE_CLOSE,MODE_MAIN,2); 
 double DIPlus1=iADX(NULL,TimeFrame,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,1); 
 double DIMinus1=iADX(NULL,TimeFrame,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,1); 
 double DIPlus2=iADX(NULL,TimeFrame,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,2); 
 double DIMinus2=iADX(NULL,TimeFrame,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,2); 
  
 if(MM==true) Lots = LotSize();
 
 if (fast01 > slow01)
 {
  BC1 = true;
  SC1 = false;
 }
 else
 {
  BC1 = false;
  SC1 = true;
 }
  
 if (ADX1 > ADX2)
 {
  BC2 = true;
  SC2 = true;
 }
 else
 {
  BC2 = false;
  SC2 = false;
 }
 
 if (DIPlus1 > DIMinus1)
 {
  BC3 = true;
  SC3 = false;
 }
 else
 {
  BC3 = false;
  SC3 = true;
 }
 
 if (DIPlus1 > DIPlus2)
 {
  BC4 = true;
 }
 else
 {
  BC4 = false;
 }

 if (DIMinus1 > DIMinus2)
 {
  SC4 = true;
 }
 else
 {
  SC4 = false;
 }
 
 if (Macd1 > Signal1)
 {
  BC5 = true;
  SC5 = false;
 }
 else
 {
  BC5 = false;
  SC5 = true;
 }

 if (Macd1 < 0  && Signal1 < 0)
 {
  BC6 = true;
 }
 else
 {
  BC6 = false;
 }

 if (Macd1 > 0  && Signal1 > 0)
 {
  SC6 = true;
 }
 else
 {
  SC6 = false;
 }

//
//Trade
//

//Long
 if(BC1 && BC2 && BC3 && BC4 && BC5 && BC6 && (CountOpenTrades()<MaxTrades))
 {
  CloseShorts();
  OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,StopLong(Bid,StopLoss),TakeLong(Ask,TakeProfit),EAName,MagicNumber,0,Blue);
 }//Long
 
//Shrt
 if(SC1 && SC2 && SC3 && SC4 && SC5 && SC6 && (CountOpenTrades()<MaxTrades))
 {
  CloseLongs();
  OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,StopShrt(Ask,StopLoss),TakeShrt(Bid,TakeProfit),EAName,MagicNumber,0,Red);
 }//Shrt
 

 
//Close Long
// if(Macd1 > 0  && Signal1 > 0 && Macd1 > Signal1)
// if(fast02 > slow02  && fast01 < slow01)
 if(Macd1 > 0  && Signal1 > 0 && Macd1 <  Signal1 && Macd2 >  Signal2)
 {
  CloseLongs();
 }//Close Long
 
 //Close Short
// if(Macd1 < 0  && Signal1 < 0 && Macd1 < Signal1)
// if(fast02 < slow02  && fast01 > slow01)
 if(Macd1 < 0  && Signal1 < 0 && Macd1 >  Signal1 && Macd2 <  Signal2)
 {
  CloseShorts();
 }//Close Short

 return(0);
}

double StopLong(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price-(stop*Point));
}

double StopShrt(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price+(stop*Point));
}

double TakeLong(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price+(take*Point));
}

double TakeShrt(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price-(take*Point));
}

void BreakEvens(int earn)
{
 int profit;
 
 if(earn<=0)
  return;
 
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES))
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;

  if(OrderType()==OP_BUY)
  {
   if(OrderOpenPrice()>OrderStopLoss())
   {
    profit=NormalizeDouble((Bid-OrderOpenPrice())/Point,0);
    if(profit>=earn)
     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Blue);
   }
  }//Long

//Shrt
  if(OrderType()==OP_SELL)
  {
   if(OrderOpenPrice()<OrderStopLoss())
   {
    profit=NormalizeDouble((OrderOpenPrice()-Ask)/Point,0);
    if(profit>=earn)
     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Red);
   }
  }//Shrt
  
 }//for
}

void TrailingAlls(int start,int stop)
{
 int profit;
 double stoptrade;
 double stopcal;
 
 if(stop==0)
  return;
 
 int trade;
 int trades=;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES))
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;

  if(OrderType()==OP_BUY)
  {
   profit=NormalizeDouble((Bid-OrderOpenPrice())/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Bid-(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal>stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Blue);
  }//Long
  
  if(OrderType()==OP_SELL)
  {
   profit=NormalizeDouble((OrderOpenPrice()-Ask)/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Ask+(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal<stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Red);
  }//Shrt
  
 }//for
}

void CloseLongs()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(OrderSelect(trade,SELECT_BY_POS,MODE_TRADES)==false)
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderType()==OP_BUY)
   OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);
 }//for
}

void CloseShorts()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(OrderSelect(trade,SELECT_BY_POS,MODE_TRADES)==false)
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderType()==OP_SELL)
   OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red);
 }//for
}

int CountOpenTrades()
{
 int count=0;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if((OrderType()==OP_SELL) || (OrderType()==OP_BUY))
   count++;
 }//for
 return(count);
}

double LotSize()
{
   double lotMM = MathCeil(AccountFreeMargin() * Risk / 10000) / 10;
   if (lotMM < 0.1) lotMM = Lots;
   if (lotMM > 1.0) lotMM = MathCeil(lotMM);
   if  (lotMM > 100) lotMM = 100;
   return (lotMM);
} 



